QGIS Application - Bug report #7638
MSSQL data provider rounds geometry on save
2013-04-17 10:27 PM - Matthew Schubert

Status: Closed

Priority: High

Assignee: Tamas Szekeres

Category: Data Provider/MSSQL

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 16559
Description

I've been using a data source coming from an MS SQL server table. | noticed on copying across points to the layer and saving it, the
points end up in a slightly different position to the source.

More investigation points to the MS SQL data provider using WKT to insert/update geometry. Because it uses
QgsGeometry::exportToWkt(), the WKT is rounded to 6 decimal places. For my source data, this resulted in inaccuracies of
approximately 50mm or so.

There is a mUseWkb flag used in QgsMssqlProvider to determine whether WKT or WKB is used, but | have no idea how to set that option
from within QGIS. Shouldn't the provider avoid rounding on updating, anyway?

Associated revisions

Revision b1efd479 - 2013-07-17 10:51 PM - Jiirgen Fischer

- introduce qgsDoubleToString for format double with maximum precision
- usage in mssql provider fixes #7638
- read precision in mssql provider (fixes #5966)

- commit errors are only shown once

History

#1 - 2013-04-17 11:59 PM - Matthew Schubert

Further investigation indicates that QgsGeometry::exportToWkt() now rounds to 8 decimal places instead of 6, as of
commit:63e8188bb9d62c9a810ee4 1f63f36c76db3cc3al. Still, | think the code should be change to introduce NO rounding errors on save.

#2 - 2013-04-18 03:59 PM - Nathan Woodrow
- Priority changed from Normal to High
- Assignee set to Tamas Szekeres

Tamas would be able to take a look at this?

#3 - 2013-07-12 10:43 AM - Paolo Cavallini
- Category set to Data Provider/MSSQL

#4 - 2013-07-17 01:52 PM - Jiirgen Fischer
- Status changed from Open to Closed

Fixed in changeset commit:"b1efd47961260f58e3536f1916dab196f3ed8d15".
